package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentClosureModel = (*customAgentClosureModel)(nil)

type (
	// AgentClosureModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentClosureModel.
	AgentClosureModel interface {
		agentClosureModel
	}

	customAgentClosureModel struct {
		*defaultAgentClosureModel
	}
)

// NewAgentClosureModel returns a model for the database table.
func NewAgentClosureModel(conn sqlx.SqlConn, c cache.CacheConf) AgentClosureModel {
	return &customAgentClosureModel{
		defaultAgentClosureModel: newAgentClosureModel(conn, c),
	}
}
