package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ QueryModel = (*customQueryModel)(nil)

type (
	// QueryModel is an interface to be customized, add more methods here,
	// and implement the added methods in customQueryModel.
	QueryModel interface {
		queryModel
	}

	customQueryModel struct {
		*defaultQueryModel
	}
)

// NewQueryModel returns a model for the database table.
func NewQueryModel(conn sqlx.SqlConn, c cache.CacheConf) QueryModel {
	return &customQueryModel{
		defaultQueryModel: newQueryModel(conn, c),
	}
}
